## camitk 6.0.0

=== CMakeLists.txt ===
#--------------------------------------------
#
#      CamiTK Community Edition CEP Set
#
#-------------------------------------------- 
cmake_minimum_required(VERSION 3.20)

project(camitkcommunityedition)

# CamiTK requires C++20
# All target after this declaration will be compile with c++20 policy
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) # for wider compatibility across plateforms and compiler

# Allow testing of the whole camitk-communityedition project
include(CTest)

set(CAMITK_PROJECT_NAME "CamiTK")
# The current version of CamiTK is defined in a separate file to avoid conflict/problem when merging
include(CamiTKVersion.cmake)
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to the Community Edition: this is the Community Edition build
set(CAMITK_COMMUNITY_EDITION_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-communityedition" CACHE STRING "CEP Set Name")

# Configure CamiTK Community Edition packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules)
set(CAMITK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
include(camitk/packaging/CamiTKCommunityEditionPackaging)
camitk_communityedition_packaging()

# Configure include-what-you-use to check the current target
include(camitk/test/CamiTKIncludeWhatYouUse)

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects (optional)
add_subdirectory(imaging)
add_subdirectory(modeling)

# ... and tutorials that helps understand CamiTK (optional)
add_subdirectory(tutorials)

camitk_write_manifest_data(CEP_SET)

=== sdk/CMakeLists.txt ===
#--------------------------------------------
#               CamiTK SDK
#
# You should probably NOT modify this file...
# Please edit CEPDescription.cmake instead
#--------------------------------------------
include(SDKConfig.cmake) 

# Configure CamiTK test coverage report generation (if and only if CAMITK_TEST_COVERAGE is set to TRUE)
include(camitk/test/CamiTKTestCoverage)

message(STATUS "Compilation build type: ${CMAKE_BUILD_TYPE}")
if (CAMITK_TEST_COVERAGE)
    message(STATUS "Test coverage: enabled")
else()
    message(STATUS "Test coverage: disabled")
endif()

# include global install of SDK
# This is a SDK build => global install is done in CMAKE_INSTALL_PREFIX
add_custom_target(camitk-ce-global-install
    COMMAND ${CMAKE_COMMAND} -E echo "Global Installation in ${CMAKE_INSTALL_PREFIX}"
    # First remove the WIN32 system runtime libraries dependencies
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_SYSTEM_RUNTIME_LIBS:STRING=" " ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."
    # Second cmake to install
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} -E echo "Global installation in ${CMAKE_INSTALL_PREFIX} done."
    COMMENT "Global installation"
)

# The definition of SDK_TOP_LEVEL_SOURCE_DIR and SDK_TOP_LEVEL_BINARY_DIR are
# are needed to store the current source dir to pass as an argument to the ConfigureCamiTKDirTxt.cmake script in camitk-ce-copy-camitkdirtxt
set(SDK_TOP_LEVEL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SDK_TOP_LEVEL_BINARY_DIR ${CMAKE_BINARY_DIR})
# specific top-level target that prepare and copy the CamiTKDir.txt file in ${CAMITK_USER_DIR}
add_custom_target(camitk-ce-copy-camitkdirtxt
    # prepare the CamiTKConfig.cmake for installation
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
                             -DCAMITK_USER_DIR=${CAMITK_USER_DIR}
                             -DSDK_TOP_LEVEL_SOURCE_DIR=${SDK_TOP_LEVEL_SOURCE_DIR}
                             -DSDK_TOP_LEVEL_BINARY_DIR=${SDK_TOP_LEVEL_BINARY_DIR}
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/ConfigureCamiTKDirTxt.cmake
    # Make sure the user dir exists
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CAMITK_USER_DIR}"
    # Remove the previous version
    COMMAND ${CMAKE_COMMAND} -E remove -f ${CAMITK_USER_DIR}/CamiTKDir.txt
    # Copy the CamiTKDir.txt file in the ${CMAKE_USER_DIR} directory
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_BINARY_DIR}/CamiTKDir.txt ${CAMITK_USER_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "CamiTKDir.txt [${CMAKE_INSTALL_PREFIX}] copied in ${CAMITK_USER_DIR}"
)

# camitk-ce-local-install == install in User Config directory
add_custom_target(camitk-ce-local-install
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR}"
    # First cmake to redefine install prefix
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CAMITK_USER_DIR} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Configuration for ${CMAKE_INSTALL_PREFIX} done."    
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target install --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -E echo "File installation done."
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt --config ${CMAKE_CFG_INTDIR}
    COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX} ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Local Installation in ${CAMITK_USER_DIR} done."
    COMMENT "Local installation"
)

# camitk-ce-update-translate == configure all the .qrc files for the different extensions of the SDK.
# .qrc files consider up to date .ts resources files for translation
add_custom_target(camitk-ce-update-translate
    COMMAND ${CMAKE_COMMAND} -E echo "Updating translation for CamiTK Community Edition"
    COMMAND ${CMAKE_COMMAND} -DCAMITK_TRANSLATE=TRUE ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -DCAMITK_TRANSLATE=FALSE ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E echo "Translation updated for CamiTK Community Edition"    
)

# make sure a copy of the CamiTKDir.txt file is written to ${CAMITK_USER_DIR}
# even if the user is just invoking the "install" target (from the IDE or command line)
install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk-ce-copy-camitkdirtxt)")

# include CamiTK auto-documentation generation
include(CamiTKApiDoc)

# python binding option
option(PYTHON_BINDING "Generate CamiTK Python Module" OFF)
if (PYTHON_BINDING)
    add_definitions(-DPYTHON_BINDING)
    message(STATUS "Generating CamiTK Python Module")
endif()

# initialize subproject management
camitk_init_manifest_data()

# initialize automatic tests parsing
camitk_parse_test_init()

# Try to find camitk-extensiongenerator binary in usual/recommanded path/variable/user directories
find_program(CAMITK_EXTENSION_GENERATOR_EXECUTABLE
    NAMES camitk-extensiongenerator-debug camitk-extensiongenerator
    PATH_SUFFIXES "bin"
    PATHS
        #-- 0. from CAMITK_DIR environment or cache variable
        "${CAMITK_DIR}"
        "$ENV{CAMITK_DIR}"

        #-- 1. Build path
        # Read from the CMakeSetup registry entries.  It is likely that
        # CamiTK will have been recently built.
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild1]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild2]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild3]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild4]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild5]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild6]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild7]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild8]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild9]
        [HKEY_CURRENT_USER\\Software\\Kitware\\CMakeSetup\\Settings\\StartPath;WhereBuild10]

        # For camitk communityedition compilation
        "${CMAKE_BINARY_DIR}"

        #-- 2. installed path
        # Unix/MacOS
        "/usr"
        "/usr/local"
        "/opt/CamiTK"
        "$ENV{HOME}/Dev/CamiTK"
        "$ENV{HOME}/Dev/camitk"
        
        # Windows
        "C:/Programs "
        "C:/Programs/CamiTK"
        "C:/Program Files/CamiTK"
        "C:/Programs/camitk"
        "C:/Program Files/camitk"
        "C:/Dev"
        "C:/Dev/CamiTK"
        "C:/Dev/camitk"

        # From last installation
        "${FIND_CAMITK_USER_DIR_LAST_INSTALL}"
)

if (NOT CAMITK_EXTENSION_GENERATOR_EXECUTABLE)
    # Fist build extension generator during the build stage so that it can be
    # reused during the normal phase.
    # see https://stackoverflow.com/a/36084786
    if (BUILD_EXTENSION_GENERATOR)
            # build the library and executable
            add_subdirectory(libraries/extensiongenerator)
            add_subdirectory(applications/extensiongenerator)   

            # and that's it, stop processing here
            return()
    endif()

    message("-- First configure: building camitk-extensiongenerator...")

    # Nested CMake run.
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}"
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    -DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}
    -DBUILD_EXTENSION_GENERATOR=ON
    -DVTK_DIR=${VTK_DIR}
    -DCAMITK_HOST_MULTIARCH=${CMAKE_LIBRARY_PATH}
    ${CMAKE_SOURCE_DIR}
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")

    # Build extensiongenerator lib and app
    execute_process(COMMAND ${CMAKE_COMMAND} --build . --target library-camitkextensiongenerator application-extensiongenerator
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")

else()
    message("-- camitk-extensiongenerator already exists. Skipping first build.")
endif()


# add all subprojects, in dependencies order
#
# Note: testapplications are easier to manage if they are in a separate directory
# As testapplications are required to test actions and components but depends on library core,
# it is easier to keep them in a separate (specific) folder.
# -> dependencies are satisfied (thanks to camitk_extension macros)
# -> parallel build is not broken
camitk_add_subdirectory(libraries)
camitk_add_subdirectory(viewers)
camitk_add_subdirectory(testapplications)
camitk_add_subdirectory(components)
camitk_add_subdirectory(actions)
camitk_add_subdirectory(applications)
camitk_add_subdirectory(cmake) # for cmake module installation

# Validate project.xml file for CDash
camitk_write_manifest_data()

# Validate CamiTKTestsLevel.txt file for wiki
camitk_parse_test_validate()

=== sdk/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately

# find components
get_subdirectories(ACTIONS_LIST)


# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  camitk_add_subdirectory(${ACTION_NAME})
endforeach()

=== sdk/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro appropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)


# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   camitk_add_subdirectory(${APPLICATION_NAME})
endforeach()

=== sdk/cmake/CMakeLists.txt ===
#
# cmake directory contains all the macro and modules for 
# developing CamiTK extensions
#
set(CAMITK_CMAKE_PATH "share/${CAMITK_SHORT_VERSION_STRING}/cmake")

##############################################################################
#                                                                            #
# Install using the local/global install target                              #
#                                                                            #
##############################################################################

# install CamiTK configuration file
install(FILES ${CMAKE_BINARY_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake/CamiTKConfig.cmake
        DESTINATION ${CAMITK_CMAKE_PATH}
)
        
# install the generic cmake files
file(GLOB CAMITK_CMAKE_FILES "modules/*.cmake")

install(FILES ${CAMITK_CMAKE_FILES}
        DESTINATION ${CAMITK_CMAKE_PATH}
)

# install the macros 
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/modules/macros
        DESTINATION ${CAMITK_CMAKE_PATH}
)


# TODO:
# - Add a custom command that depends on the specified files and runs the install step
# - Add a custom target that depends on the output of the custom command
#
# Something like
# set(EXPORT_CAMITK_CMAKE_MACROS sdk-export-cmake-macros)
# add_custom_command(TARGET ${EXPORT_CAMITK_CMAKE_MACROS}
#                    POST_BUILD
#                    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CAMITK_CMAKE_FILES} ${CAMITK_CMAKE_PATH}
#                    COMMENT "Installing build-time cmake macros"
#                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
#                    VERBATIM
# )
# add_custom_command(TARGET ${EXPORT_CAMITK_CMAKE_MACROS}
#                    POST_BUILD
#                    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/modules/macros ${CAMITK_CMAKE_PATH}
#                    COMMENT "Installing build-time cmake macros directory"
#                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
#                    VERBATIM
# )

=== sdk/components/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(COMPONENT_EXTENSION ...) macro appropriately

# find components
get_subdirectories(COMPONENTS_LIST)


# Add subdirectories in CMake project
foreach(COMPONENT_NAME ${COMPONENTS_LIST})
  camitk_add_subdirectory(${COMPONENT_NAME})
endforeach()

=== sdk/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro appropriately


# add the library in the dependencies order
camitk_add_subdirectory(extensiongenerator)
camitk_add_subdirectory(qtpropertybrowser)
camitk_add_subdirectory(core)
camitk_add_subdirectory(cepcoreschema)
camitk_add_subdirectory(cepgenerator)
camitk_add_subdirectory(python)

=== sdk/viewers/CMakeLists.txt ===
# add viewer manually as the dependencies does not depend on the alphabetical order
# and this does not seem to be recognize automatically by CMake

# independent viewers
camitk_add_subdirectory(actionviewer)
camitk_add_subdirectory(componentexplorer)
camitk_add_subdirectory(propertyexplorer)
camitk_add_subdirectory(transformationexplorer)

# 3D viewers by order of dependencies
camitk_add_subdirectory(interactivegeometryviewer)
camitk_add_subdirectory(interactivesliceviewer)
camitk_add_subdirectory(medicalimageviewer)
camitk_add_subdirectory(bitmap)

=== tutorials/viewers/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a viewer, just add a subdirectory (the viewer name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(VIEWER_EXTENSION ...) macro appropriately

# find components
get_subdirectories(VIEWERS_LIST)


# Add subdirectories in CMake project
foreach(VIEWER_NAME ${VIEWERS_LIST})
  camitk_add_subdirectory(${VIEWER_NAME})
endforeach()

=== imaging/actions/itkfilters/CMakeLists.txt ===
# On windows 64 bits platform, enable big obj (.o) handling, in order to correctly compile this (heavy) project
if (WIN32)
    if(CMAKE_CL_64)
        if (MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
        elseif(MINGW)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -finline-functions")
        endif()
    endif()
endif()

# Create a specific pool, so that parallel build is optimize to reduce memory management
include(ProcessorCount)
ProcessorCount(NUMBER_OF_PROC)
# remove some to avoid processor overload
if (MSVC)
    # trying to avoid "fatal error c1060, the compiler is out of heap space"
    set(NUMBER_OF_PROC_OPTIMAL 2)
else()
    math(EXPR NUMBER_OF_PROC_OPTIMAL "${NUMBER_OF_PROC} / 2")
endif()
if(NUMBER_OF_PROC_OPTIMAL GREATER 0)
    message(STATUS "Detected ${NUMBER_OF_PROC} processors but using only ${NUMBER_OF_PROC_OPTIMAL} for building itkfilters")
    set_property(GLOBAL PROPERTY JOB_POOLS itk_filters_pool=${NUMBER_OF_PROC_OPTIMAL})
endif()

camitk_extension(ACTION_EXTENSION
                 NEEDS_ITK
                 NEEDS_CEP_LIBRARIES camitkitktemplates
                 CXX_FLAGS "-w"
                 CEP_NAME CEP_IMAGING
                 DESCRIPTION "This action features basic ITK image processing filters"
                 DEFINES COMPILE_ITKFILTER_API
                 ENABLE_AUTO_TEST
                 TEST_FILES bassin.msh BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img biorad.pic brain.mha cthead1.lsm LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr mini-complex-slow1.nrrd mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd ramp1.gipl
                 ENABLE_INTEGRATION_TEST
)

if(NUMBER_OF_PROC_OPTIMAL GREATER 0)
    set_property(TARGET action-itkfilters PROPERTY JOB_POOL_COMPILE itk_filters_pool)
endif()

# --------------------------------
# --- Specific test management ---
# --------------------------------
camitk_disable_tests(TESTS action-itkfilters-level1-6
                           action-itkfilters-level1-8
                           action-itkfilters-level1-14
                     REASON "Test failure due to ITK exception.
  When applying action Gradient Magnitude With Smoothing to test files
  biorad.pic, cthead1.lsm, mini-complex-slow1.nrrd, the following exception
  is raised:
  \"camitk-testcomponents aborted by std exception: 
  /usr/include/ITK-5.2/itkRecursiveSeparableImageFilter.hxx:224:
  ITK ERROR: RecursiveGaussianImageFilter(0x55d1275a5760): The number of
  pixels along direction 2 is less than 4. This filter requires a minimum
  of four pixels along the dimension to be processed\""
)

camitk_tests_requirement(TESTS action-itkfilters-integration-test
                         REQUIRES "NOT WIN32"
                         REASON "WIN32 OpenGL failure on a VM
  This test will always fail when run inside a VM due to OpenGL crash.
  This test will pass when run directly from a physical windows machine."
)

camitk_tests_requirement(TESTS action-itkfilters-integration-test
                         REQUIRES "${VTK_VERSION} VERSION_EQUAL 9.1.0"
                         REASON "VTK version is not equals than 9.1.0
  The default test files are written using the currently supported 
  version of VTK (VTK 9.1).
  This test might therefore fail when comparing the input to the 
  output if another version of VTK is used.
  Although everything should work fine, the output diff will make
  this test unconditionally fail."
)

=== imaging/actions/itksegmentation/CMakeLists.txt ===
camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    NEEDS_ACTION_EXTENSION multipicking
                    NEEDS_CEP_LIBRARIES camitkitktemplates
                    CEP_NAME CEP_IMAGING
                    CXX_FLAGS "-w"
                    DESCRIPTION "This action features basic ITK image processing segmentation algorithms"
                    ENABLE_AUTO_TEST
                    TEST_FILES Mesh.off BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img biorad.pic brain.mha cthead1.lsm LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr mini-complex-slow1.nrrd mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd ramp1.gipl
)

=== imaging/actions/totalsegmentator/CMakeLists.txt ===
camitk_add_subdirectory(actions)

=== debian/changelog ===
camitk (6.0.0-3) unstable; urgency=medium

  * Minor user issue fixed: due to the new extension system,
    libcamitk-dev should always be installed with camitk-imp so that
    the tools needed to create and load extensions are available.
    Adding this to the debian/control file.
   * Patching a .desktop file to fix Appstream error

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Tue, 10 Feb 2026 18:52:08 +0100

camitk (6.0.0-2) unstable; urgency=medium

  * Installation from experimental tested successfully, minor UI issue fixed
    in new patch, hopefully ready to switch to unstable

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Tue, 20 Jan 2026 19:20:04 +0100

camitk (6.0.0-1) experimental; urgency=medium

  * New upstream version 6.0.0 (Closes: #1117520)

 -- Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>  Wed, 14 Jan 2026 10:27:12 +0100

camitk (5.2.0-5) unstable; urgency=medium

  * Adding safeguards around ctest instructions. (Closes: #1103471)

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Sat, 19 Apr 2025 17:23:55 +0200

camitk (5.2.0-4) unstable; urgency=medium

  * use VTK9 modules to remove unneeded java dependencies
  * remove doxygen xml output to improve reproducibility
  * fix dh_missing and patch format warnings

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Sat, 15 Mar 2025 14:05:12 +0100

=== debian/control ===
Source: camitk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>,
           Manik Bhattacharjee <manik.bhattacharjee@univ-grenoble-alpes.fr>
Section: science
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               libvtk9-dev,
               qt6-base-dev,
               qt6-tools-dev,
               qt6-scxml-dev,
               xsdcxx,
               libinsighttoolkit5-dev,
               libfftw3-dev,
               libgdcm-dev,
               libgdcm-tools,
               libvtkgdcm-dev,
               libpython3-dev,
               python3-dev,
               python3-pip,
               python3-venv,
               pybind11-dev,
               xvfb,
               xauth,
               doxygen,
               graphviz
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/camitk
Vcs-Git: https://salsa.debian.org/med-team/camitk.git
Homepage: https://camitk.imag.fr/

Package: libcamitk6
Architecture: any
Section: libs
Depends: libqtpropertybrowser6 (= ${binary:Version}),
         python3,
         libpython3-dev,
         python3-venv,
         python3-pyside6.qtwidgets,
         python3-vtk9,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-config
Breaks: libcamitk5
Replaces: libcamitk5
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: camitk-config
Architecture: any
Depends: libcamitk6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - config
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains a command-line application to diagnose and check
 the CamiTK configuration and environment setup.

Package: libcamitk-dev
Architecture: any
Section: libdevel
Depends: libcamitk6 (= ${binary:Version}),
         camitk-config,
         libqtpropertybrowser-dev,
         cmake,
         libvtk9-dev,
         libvtk9-qt-dev,
         qt6-base-dev,
         qt6-tools-dev,
         qt6-scxml-dev,
         xsdcxx,
         libinsighttoolkit5-dev,
         libfftw3-dev,
         libgdcm-dev,
         libgdcm-tools,
         libvtkgdcm-dev,
         xvfb,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: camitk-imp
Suggests: camitk-actionstatemachine
Breaks: libcamitk5
Replaces: libcamitk5
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard application to create new
 extensions.

Package: libcamitk6-data
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the examples and test data for CamiTK.

Package: libcamitk6-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: libcamitk-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: camitk-actionstatemachine
Description: workbench application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-imp
Description: pipeline replay application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow on to replay interactive the described state-machine containing a
 list of CamiTK actions and transitions.

Package: libqtpropertybrowser6
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libqtpropertybrowser5
Replaces: libqtpropertybrowser5
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser6.

Package: libqtpropertybrowser-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser6 (= ${binary:Version}),
         ${misc:Depends}
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# CamiTK version from d/changelog)
include /usr/share/dpkg/pkg-info.mk
FULL_VERSION := $(shell echo '$(DEB_VERSION)' | sed -e 's/^[[:digit:]]*://' -e 's/[~-].*//')
VER_MAJOR := $(shell echo '$(FULL_VERSION)' | cut -f1 -d".")
VER_MINOR := $(shell echo '$(FULL_VERSION)' | cut -f2 -d".")
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_cfg = camitk-config
pkg_dev = libcamitk-dev
pkg_qpb_dev = libqtpropertybrowser-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine
PKG_LIB_DIR := $(CURDIR)/debian/$(pkg_lib)/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)
LIB_BUILD_DIR := $(CURDIR)/camitk-build/lib/$(DEB_HOST_MULTIARCH)
PRIVATE_LIB_BUILD_DIR := $(LIB_BUILD_DIR)/camitk-$(VER_SHORT)

# List of python tests that require to install some PyPI packages, they should be not run during packaging
# (no execution of code outside the source package)
EXCLUDED_PYTHON_TESTS := "'(test-pythonhotplug-image|test-pythonhotplug-mesh|test-pythonhotplug-state|test-pythonhotplug-qt|test-pythonhotplug-meshPoints|test-pythonhotplug-transformationManager|test-pythonhotplug-userScriptValidity|test-pythonhotplug-actionPipeline|test-pythonscript-scriptVariable|test-pythonscript-numpyImageComponent|test-pythonscript-core|test-pythonscript-vtk)'"

# multi-arch support
include /usr/share/dpkg/architecture.mk

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
# Notes:
# - if you would like a more verbose camitk at run-time,
#   you can add -DCAMITK_LOG_LEVEL=2
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=TRUE \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=FALSE \
	-DCMAKE_BUILD_TYPE:STRING=None \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	-DCEP_TUTORIALS:BOOL=TRUE \
	\
	-DPYTHON_BINDING:BOOL=TRUE \
	-DPYTHON_BINDING_TEST_DISABLE:BOOL=TRUE \
	\
	-DAPIDOC_SDK:BOOL=TRUE

# Verbose is required by blhc to remove errors about pre-build of extensiongenerator lib and executable
%:
	VERBOSE=1 QT_QPA_PLATFORM=offscreen dh $@ --builddirectory=camitk-build --with python3

override_dh_auto_configure:
	# modify libdir to include multiarch
	sed -i 's+return "lib";+return "lib/$(DEB_HOST_MULTIARCH)";+g' sdk/libraries/core/CamiTKVersion.h
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	# Building API DOC
	dh_auto_build -- camitk-ce-api-doc
	# Building all (required to avoid cmake error)
	dh_auto_build

# No tests needed for docs
override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "No tests availaible just for the docs"
endif

# run all the available tests (only for Archictecture: any
# as tests can only be run if and once the framework is build)
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Some tests generate source code and build it but do not receive the hardening flags
	# As this generated source code do not end up in the distributed binary,
	# this can be considered as blhc false positive : just ignore them
	@echo 'blhc: ignore-line-regexp: .*camitk-test-tmp.*'
	@echo 'blhc: ignore-line-regexp: .*CamiTKExtensionCheck.*'
	@echo 'blhc: ignore-line-regexp: .*CMakeCXXCompilerABI.cpp.*'
	# Use the CamiTK test suite
	# Note: all tests require an X server, xvfb-run is needed to have a virtual one
	# Another way: xvfb-run --auto-servernum $(MAKE) -C camitk-build ARGS="-V" test
	# e.g. to test config: (cd camitk-build && xvfb-run --auto-servernum --server-args="-screen 0 1024x768x24" ctest -VV --timeout 1800 -R application-config)
	# The build dir path is needed for extensions, public and private libraries during test
	# to know about all camitk extension directories and properly manage inner-dependencies
	# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
	# Lib dependencies can be in any extensions (viewers, component and action extensions) lib directory
	export LD_LIBRARY_PATH=$(LIB_BUILD_DIR)/:$(PRIVATE_LIB_BUILD_DIR)/viewers/:$(PRIVATE_LIB_BUILD_DIR)/components/:$(PRIVATE_LIB_BUILD_DIR)/actions/:$(PRIVATE_LIB_BUILD_DIR)/ ; \
	(cd camitk-build && xvfb-run --auto-servernum --server-args="-screen 0 1024x768x24" ctest -V --timeout 1800 --exclude-regex "$(EXCLUDED_PYTHON_TESTS)")
endif

# packages for specific arch
override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libmonitoring.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkextensiongenerator.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkitktemplates.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/python3/dist-packages/camitk.cpython*.so
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/viewers/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/components/lib*.so.*

	# camitk-config package contains only the app, man page and icon
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
	dh_installman -p$(pkg_cfg) debian/tmp/usr/share/man/man1/camitk-config.1

	# separate packaging for qtpropertybrowser (can be used independently from camitk)
	dh_install -p$(pkg_qpb) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libqtpropertybrowser.so.*

	# camitk developer package
	# camitk so and headers and static libs
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkcore.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libmonitoring.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkextensiongenerator.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libcamitkitktemplates.so usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/viewers/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/cepcoreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/camitkextensiongenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/camitkitktemplates
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/viewers
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/pmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-$(VER_SHORT)/libraries/pml

=== debian/tests/control ===
# see https://people.debian.org/~eriberto/README.package-tests.html for the syntax
Tests: config-test.sh, cepgenerator-test.sh, extensiongenerator-test.sh
# libgl1-mesa-dri and dbus are needed just to avoid warnings that confuse the config test
# g++ is needed to compile the C++ code generated by cepgenerator in the wizard test
Depends: libcamitk-dev, g++, dbus, libgl1-mesa-dri
# this restriction is needed to avoid test abortion due to output to stderr
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: https://gricad-gitlab.univ-grenoble-alpes.fr/CamiTK/CamiTK.git
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
